package cokr.xit.fims.rcvm.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.foundation.AbstractComponent;
import cokr.xit.foundation.data.DataObject;

import cokr.xit.fims.rcvm.Rcvmt;
import cokr.xit.fims.rcvm.RcvmQuery;
import cokr.xit.fims.rcvm.dao.RcvmtMapper;

/**수납 대장 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-31	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("rcvm01Bean")
public class Rcvm01Bean extends AbstractComponent {

	/** 수납 대장 정보 DAO */
	@Resource(name = "rcvmtMapper")
	private RcvmtMapper rcvmtMapper;

	/**지정한 조건에 따라 수납 대장 목록을 조회하여 반환한다.
	 * @param req 수납 대장 조회 조건
	 * @return 수납 대장 목록
	 */
	public List<DataObject> getRcvmtList(RcvmQuery req) {
		return rcvmtMapper.selectRcvmtList(req);
	}

	/**지정한 조건에 따라 수납 대장 객체들을 반환한다.
	 * @param req 수납 대장 조회 조건
	 * @return 수납 대장 객체 목록
	 */
	public List<DataObject> getRcvmts(RcvmQuery req) {
		return rcvmtMapper.selectRcvmts(req);
	}

	/**수납 대장 정보를 등록한다.
	 * @param rcvmt 수납 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean createRcvmt(Rcvmt rcvmt) {
		return rcvmtMapper.insert(rcvmt);
	}

	/**수납 대장 정보를 수정한다.
	 * @param rcvmt 수납 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean updateRcvmt(Rcvmt rcvmt) {
		return rcvmtMapper.update(rcvmt);
	}

	/**수납 대장 정보를 삭제한다.
	 * @param rcvmt 수납 대장
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean removeRcvmt(Rcvmt rcvmt) {
		return rcvmtMapper.delete(rcvmt);
	}
}
